Localization Sample
===================

This sample demonstrates the use of localized strings to generate output in the user's language.

The localized strings are stored as JSON to make it simpler to read within scripts. 

The sample consists of the following files:
* The `sample-localization.OL-datamapper` runs on the `data.xml` file. A single Automation property (presumably a Global or Local Variable coming from a PlanetPress Workflow process) contains the path to the localization files.
* The `sample-localization.OL-template` displays the localized output in a Print context (but any context can be used).
* The `translations/` folder contains the localization files in JSON format.

### Test the Demo

To test the demo, open both the `sample-localization.OL-datamapper` and `sample-localization.OL-template` in the Connect Designer application. In the data mapping configuration, edit the properties of the Preprocessor step, and change the path of the `TranslationsPath` automation property. This should reflect the location where the JSON files are located.

### FAQ

**Q**: Why is the data within the the detail table (such as the Description field) not localized?  
**A**: Because this is part of the data, not the template. The data coming from whichever system generates it should already be localized. For instance, most ERP/CRM systems have the capability to generate localized data output.

**Q**: Can I have variable data within the localization strings?  
**A**: Yes. In this sample, the customer name is actually within the localization string. This simplifies things especially when variable data appears within localized sentences. Please note that the localization script ("Apply translations" in the Scripts pane) must be executed *first*, before the Text scripts are run.

**Q**: Could the localization files be in another format than JSON?  
**A**: Yes, but the code would be more complex and much less efficient. JSON data is read almost instantly, whereas in the case of other formats such as CSV, XML, or Text, you would need to parse the file itself for each string. A database would be a little simpler in terms of code but a lot of requests would be done, we don't suggest that. It's advised to convert any localization format to JSON, for effiency and simplicity's sake.
